let args = ref []
let usage = "usage: pac-mdl_bound <train_example_number> <train_example_error_number> <bit_description_length> <test_example_number> <bound_error_rate>\n"

exception Badness

let _ = 
  Arg.parse [] (fun x -> args := x::!args) usage;
  try 
    if List.length !args <> 5 then raise Badness;
    let m = int_of_string (List.nth !args 4)
    and a = int_of_string (List.nth !args 3)
    and d = float_of_string (List.nth !args 2)
    and n = int_of_string (List.nth !args 1)
    and delta = float_of_string (List.nth !args 0) in
    
    let bound = Hypergeometric.upper_bound m n a (log delta -. d *. log 2.) in
    print_int bound;
    print_newline();
    print_string ("assuming i.i.d. samples, with probability at least "
		  ^string_of_float (1. -. delta)
		  ^" there at most "^string_of_int bound^" errors in the test set\n"); 
  with
    _ -> print_string usage
